# -------------------------------------------------------------------------------------------------
#<profile4xi profile = "11" />
#<program4xi program = "platforminfo4xi5test.py">
#<abstract4xi abstract = "tests platforminfo4xi"/>
#<verify4xi verification = "11" target = "platforminfo4xi5test.py"/>
#<contextualize4xi context = "print4xi.py"/>
#<use4xi usage = "
# SET:
# 
# RUN:
# > python platforminfo4xi5test.py > E:\scope4xi\041721\zap\work\txt\platforminfo4xi5test.txt
#
# ANALYZE:
#
# sense-test-platforminfo4xi5test.xml     <-- trace in XML
# reason-test-platforminfo4xi5test.xml
# ace-test-platforminfo4xi5test.xml
# platforminfo4xi5test.txt                <-- OF PLATFORMINFO4XI5TEST
#"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = "  
__all__ = [ 'main',
            'print2trace4xi',
            'platforminfo4xi5test',
            'set_trace4xi']
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread   

import signal
import itertools
import weakref
import logging  
#"
#/>


# -------------------------------------------------------------------------------------------------
# Scope4Xi imports                               
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi
 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>



# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "

from platforminfo4xi import PlatformInfo4Xi
from platforminfo4xi import init2platforminfo4xi
from platforminfo4xi import set2platforminfo4xi
from platforminfo4xi import get2platforminfo4xi

from print4xi import Print4Xi
from print4xi import print4xi

from pickle4xi import pickle4xi
from pickle2a4xi import Pickle2a4Xi
from pickle2b4xi import Pickle2b4Xi
from pickle2c4xi import Pickle2c4Xi
from pickle2d4xi import Pickle2d4Xi
from pickle2e4xi import Pickle2e4Xi
from pickle2f4xi import Pickle2f4Xi
from pickle2g4xi import Pickle2g4Xi
from pickle2h4xi import Pickle2h4Xi
from pickle2i4xi import Pickle2i4Xi
from pickle2j4xi import Pickle2j4Xi
from pickle2k4xi import Pickle2k4Xi
from pickle2l4xi import Pickle2l4Xi
from pickle2m4xi import Pickle2m4Xi
from pickle2n4xi import Pickle2n4Xi
from pickle2o4xi import Pickle2o4Xi
from pickle2p4xi import Pickle2p4Xi
from pickle2q4xi import Pickle2q4Xi
from pickle2r4xi import Pickle2r4Xi
from pickle2s4xi import Pickle2s4Xi
from pickle2t4xi import Pickle2t4Xi
from pickle2u4xi import Pickle2u4Xi
from pickle2v4xi import Pickle2v4Xi
from pickle2w4xi import Pickle2w4Xi
from pickle2x4xi import Pickle2x4Xi
from pickle2y4xi import Pickle2y4Xi
from pickle2z4xi import Pickle2z4Xi
from pickle2_4xi import Pickle2_4Xi      

from time4xi import time4xi

from xml_trace_sense4xi import xml_trace_sense4xi
from xml_trace_reason4xi import xml_trace_reason4xi
from xml_trace_ace4xi import xml_trace_ace4xi 
#" 
#/>


# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global trace2scope 
global trace_object_count
global PickleKB4Xi

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
PickleKB4Xi = {
       'a': Pickle2a4Xi,
       'b': Pickle2b4Xi,
       'c': Pickle2c4Xi,
       'd': Pickle2d4Xi,
       'e': Pickle2e4Xi,
       'f': Pickle2f4Xi,
       'g': Pickle2g4Xi,
       'h': Pickle2h4Xi,
       'i': Pickle2i4Xi,
       'j': Pickle2j4Xi,
       'k': Pickle2k4Xi,
       'l': Pickle2l4Xi,
       'm': Pickle2m4Xi,
       'n': Pickle2n4Xi,
       'o': Pickle2o4Xi,
       'p': Pickle2p4Xi,
       'q': Pickle2q4Xi,
       'r': Pickle2r4Xi,
       's': Pickle2s4Xi,
       't': Pickle2t4Xi,
       'u': Pickle2u4Xi,
       'v': Pickle2v4Xi,
       'w': Pickle2w4Xi,
       'x': Pickle2x4Xi,
       'y': Pickle2y4Xi,
       'z': Pickle2z4Xi,
       '_': Pickle2_4Xi} 
#"
#"/>


# ----------------------------------------------------------------------------------------------------------
#<function4xi function = "set2trace4xi" usage = "setting trace using definitions in pickle4xi functions !
#">                      
# ----------------------------------------------------------------------------------------------------------    
def set2trace4xi():
    global trace2scope 
    global trace_object_count
    global PickleKB4Xi

    # print("(Step 0A/33) OF SET2TRACE4XI - STARTING SETTING TRACE BASED ON TRACE SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    # print("(Step 0B/33) OF SET2TRACE4XI - USING T2XI: ", trace2scope)
    # <print4xi.Print4Xi object at 0x0000000003715080>    
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('=' *33)
        # print("STARTING LETTER : ", key2pickledb)
        # print('=' *33)
   
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("STARTING DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
        # 
        keys2dictionary = sorted(dictionary2pickle.keys())
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
            # -------------------------------------------------------------------------------------     
            # print('~' *33)        
            object2pickle = key2dictionary        
            # print("STARTING OBJECT: ", object2pickle)
            # print('~' *33)         
            # pickle4xi(object2pickle)
            # print('~' *33)                  
            # print("PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            # ---------------------------------------------------------------------------------    
            # Mark those with NACK4XI to be traced !
            # ---------------------------------------------------------------------------------     
            if dictionary2pickle[key2dictionary] == 'NACK4XI':
                set_param2xi = True     
                key_param = object2pickle     
                trace2scope.set_print_permission(key_param, set_param2xi)
                # print("(Step 2A/33) OF SET2TRACE4XI - MARKED TO BE TRACED OBJECT: ", object2pickle)                                
                # 
            else:
                pass  
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('~' *33)        
        # print("COMPLETED  DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print('=' *33)
    # print("COMPLETED LETTER : ", key2pickledb)
    # print('=' *33)
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------
    print('=' *33)
    print("(Step 33/33) OF SET2TRACE4XI - COMPLETED SETTING TRACE BASED ON NACK4XI/ACK4XI SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print('=' *33)
#</function4xi> 

       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "deny2trace4xi" usage = "
#   deny trace using pickle4xi functions !
#">                      
# -------------------------------------------------------------------------------------------------    
def deny2trace4xi():
    global trace2scope 
    global trace_object_count
    global PickleKB4Xi

    print("(Step 01A/33) of DENY2TRACE4XI: STARTING DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print("(Step 01B/33) OF DENY2TRACE4XI - USING T2XI: ", trace2scope)
    # <print4xi.Print4Xi object at 0x0000000003715080>
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02A/33) OF DENY2TRACE4XI - STARTING LETTER : ", key2pickledb)
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("(Step 02B/33) OF DENY2TRACE4XI - STARTING DICTIONARY: ", dictionary2pickle)
        keys2dictionary = sorted(dictionary2pickle.keys())
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
   
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
   
            object2pickle = key2dictionary        
            # print("(Step 02C/33) OF DENY2TRACE4XI - STARTING OBJECT: ", object2pickle)
            # pickle4xi(object2pickle)        
            # print("STEP: PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            
            # ---------------------------------------------------------------------------------    
            # ACK4XI = tested .i.e. NOT to be traced! 
            # ---------------------------------------------------------------------------------     
            set_param2xi = 'ACK4XI'     
            key_param = object2pickle     
            trace2scope.set_print_permission(key_param, set_param2xi)
            # print("(Step 02D/33) OF DENY2TRACE4XI - MARKED TESTED AND NOT to be traced: ", object2pickle)
            
            dictionary2pickle[key2dictionary] = 'ACK4XI' 
                    
        
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
            # print('~' *33)              
            # print("(Step 02Z/33) OF DENY2TRACE4XI *** FAILED - ERROR IN PICKLING OBJECT - NOT TO BE TRACED: ", object2pickle)
            # print('~' *33) 
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02E/33) OF DENY2TRACE4XI - COMPLETED  DICTIONARY: ", dictionary2pickle)
        # 
        
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print("(Step 02F/33) OF DENY2TRACE4XI - COMPLETED LETTER : ", key2pickledb)
    # _, a ... z            
    print("(Step 033/33) OF SET2TRACE4XI - COMPLETED DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "tailor2trace4xi" usage = "
#   tailors trace 
#">                      
# -------------------------------------------------------------------------------------------------    
def tailor2trace4xi():
    global trace_object_count
    global PickleKB4Xi 
    global trace2scope
 
    print("(Step 001A/33) OF TAILOR2TRACE4XI - USING T2XI: ", trace2scope)
    # <print4xi.Print4Xi object at 0x0000000003715080> 
                         
    # ---------------------------------------------------------------------------------------------
    # Settings to tailor trace
    # ---------------------------------------------------------------------------------------------
    #<set4xi setting = "
    KB4Tailoring = {
         'PlatformInfo4Xi': 'NACK4TRACE',
         'init2platforminfo4xi': 'NACK4TRACE',
         'get2platforminfo4xi': 'NACK4TRACE',
         'set2platforminfo4xi': 'NACK4TRACE'
        }                              
                
    default3trace = 'NACK4TRACE' # we do NOT want trace if object is not found! 
    #"/>
    
    # ---------------------------------------------------------------------------------------------
    # PROCESS KB4Tailoring
    # ---------------------------------------------------------------------------------------------
    keys2tailor = sorted(KB4Tailoring.keys())
    for key2tailor in keys2tailor:
        # ---------------------------------------------------------------------------------    
        # NACK4XI = NOT TESTED .I.E. TO BE TRACED! 
        # ---------------------------------------------------------------------------------     
        set_param2xi = 'NACK4XI'     
        key_param = key2tailor    
        trace2scope.set_print_permission(key_param, set_param2xi)
        print("(Step 002A/33) OF TAILOR_TRACE4XI - MARKED TO BE TESTED: ", key2tailor)
        # 
        
    # -----------------------------------------------------------------------------------------    
    # EOF KEYS
    # -----------------------------------------------------------------------------------------     
    print("(Step 0033/33) OF TAILOR_TRACE4XI - COMPLETED  TAILORING: ", time4xi())
    #

    
#</function4xi>              
       

    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "print-trace4xi" usage = "
# print XML trace for platforminfo4xi test
#"> 

# -------------------------------------------------------------------------------------------------    
def print2trace4xi(trace2scope):
       

    # -------------------------------------------------------------------------------------------------
    # SENSE                        
    # -------------------------------------------------------------------------------------------------  
   
    context2sense = {
     'file_path4xi': 'E:\\scope4xi\\041721\\zap\\web\\xml\\sense-platforminfo4xi5test.xml',
     'name_space4xi': '   xmlns="http://www.yourdragonxi.org/sw4xi/python33/owl/multiprocessing4dragon.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.yourdragonxi.org/web/lib/owl/scope4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Sensing of OpenCl4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Classes, methods and messages with context.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="Dragon4Xi#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Sensing Platform Info in system.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="sensed#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">Y-Skeleton sensed in system.</rdfs:comment>\n',
     'debug4xi': True}
      
    xml_trace_sense4xi(trace2scope, context2sense)

    # -------------------------------------------------------------------------------------------------
    # REASON                         
    # -------------------------------------------------------------------------------------------------  
        
    context2reason = {
     'file_path4xi': 'E:\\scope4xi\\041721\\zap\\web\\xml\\reason-platforminfo4xi5test.xml',
     'name_space4xi': '   xmlns="http://www.yourdragonxi.org/sw4xi/python33/owl/multiprocessing4dragon.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.yourdragonxi.org/web/lib/owl/scope4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Reasoning of OpenCl4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Operations</rdfs:comment>\n',
     'operation_comment4xi': '      <rdfs:comment xml:lang="en">Operations for Platform Info in system.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="reasoned#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Operations with context.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="reason#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">reason</rdfs:comment>\n',
     'debug4xi': True}
       
    xml_trace_reason4xi(trace2scope, context2reason)

    # -------------------------------------------------------------------------------------------------
    # ACE                         
    # -------------------------------------------------------------------------------------------------  
       
    context2ace = {
     'file_path4xi': 'E:\\scope4xi\\041721\\zap\\web\\xml\\ace-platforminfo4xi5test.xml',
     'name_space4xi': '   xmlns="http://www.yourdragonxi.org/sw4xi/python33/owl/multiprocessing4dragon.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.yourdragonxi.org/web/lib/owl/scope4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Acing of OpenCl4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for Platform Info in system.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="ACE4Xi#0000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values of Platform Info.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="ace#0000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">000000</rdfs:comment>\n',
     'debug4xi': True}   
    
    xml_trace_ace4xi(trace2scope, context2ace)


    # -------------------------------------------------------------------------------------------------
    # end of print2trace4xi                        
    # -------------------------------------------------------------------------------------------------  
#</function4xi>
       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "platforminfo4xi5test" usage = "
# tests platforminfo4xi
#"> 

# -------------------------------------------------------------------------------------------------    
def platforminfo4xi5test():

    # ---------------------------------------------------------------------------------------------
    # START                          
    # ---------------------------------------------------------------------------------------------    
    print('=' *33)          
    print('(Step 1A/33) OF platforminfo4XI5TEST - STARTED ', time4xi())
    print('=' *33)   
    
    # ---------------------------------------------------------------------------------------------
    # PHASE I: FUNCTION TESTS                          
    # ---------------------------------------------------------------------------------------------
    
    # ---------------------------------------------------------------------------------------------
    # INITIALIZE WITH FUNCTION                          
    # ---------------------------------------------------------------------------------------------    
    print('=' *33)          
    print('(Step 2A/33) of platforminfo4XI5TEST - TRYING TO INITIALIZE platforminfo4XI', time4xi())
    print('=' *33)       
    try:
        platform2xi = init2platforminfo4xi()                                                                        # no parameters - let the system decide   
        print('(Step 2B/33) of platforminfo4XI5TEST - INITIALIZED platforminfo4XI TO: ', platform2xi)               # {    'profile': 'FULL_PROFILE', 
                                                                                                                    #   'extensions': 'cl_khr_icd cl_amd_event_callback cl_amd_offline_devices cl_khr_d3d10_sharing', 
                                                                                                                    #      'version': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 
                                                                                                                    #       'vendor': 'Advanced Micro Devices, Inc.', 
                                                                                                                    #         'name': 'ATI Stream'
                                                                                                                    #}

    except:
        print('(Step 2Z/33) of platforminfo4XI5TEST *** FAILED TO INITIALIZE platforminfo4XI', time4xi()) 
    
    # ---------------------------------------------------------------------------------------------
    # GET WITH FUNCTION                          
    # ---------------------------------------------------------------------------------------------    
    print('=' *33)          
    print('(Step 3A/33) of platforminfo4XI5TEST - TRYING TO GET platforminfo4XI', time4xi())
    print('=' *33)    
    try:
        
        platform2xi = get2platforminfo4xi()
        print('(Step 3B/33) of platforminfo4XI5TEST - GOT platforminfo4XI: ', platform2xi)                          # {   'profile': 'FULL_PROFILE', 
                                                                                                                    #  'extensions': 'cl_khr_icd cl_amd_event_callback cl_amd_offline_devices cl_khr_d3d10_sharing', 
                                                                                                                    #     'version': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 
                                                                                                                    #      'vendor': 'Advanced Micro Devices, Inc.', 
                                                                                                                    #        'name': 'ATI Stream'
                                                                                                                    # }

    except:
        print('(Step 3Z/33) of platforminfo4XI5TEST *** FAILED TO GET platforminfo4XI', time4xi())
            
    
    # ---------------------------------------------------------------------------------------------
    # SET WITH FUNCTION                          
    # ---------------------------------------------------------------------------------------------    
    print('=' *33)          
    print('(Step 4A/33) of platforminfo4XI5TEST - TRYING TO SET platforminfo4XI', time4xi())
    print('=' *33)       
    try:
        platform4xi = set2platforminfo4xi()                                                                         # no parameters - let the system decide       
        print('(Step 4B/33) of platforminfo4XI5TEST - SET platforminfo4XI TO: ', platform4xi)                       # {'profile': 'FULL_PROFILE', 'extensions': 'cl_khr_icd cl_amd_event_callback cl_amd_offline_devices cl_khr_d3d10_sharing', 'version': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'vendor': 'Advanced Micro Devices, Inc.', 'name': 'ATI Stream'}
    except:
        print('(Step 4Z/33) of platforminfo4XI5TEST *** FAILED TO SET platforminfo4XI', time4xi())
   
    # ---------------------------------------------------------------------------------------------
    # PHASE II: class tests                          
    # ---------------------------------------------------------------------------------------------
    print('=' *33)          
    print('(Step 5A/33) of platforminfo4XI5TEST - CREATING PLATFORMINFO4XI OBJECT')
    print('=' *33)  
    try:
        # ---------------------------------------------------------------------------------------------
        # CREATE OBJECT                        
        # ---------------------------------------------------------------------------------------------        
        info2xi = PlatformInfo4Xi()
        print('(Step 5B/33) of platforminfo4XI5TEST - CREATED PLATFORMINFO4XI OBJECT: ', info2xi)                   # <platforminfo4xi.PlatformInfo4Xi object at 0x00000000031A4F28> 
    except:
        print('(Step 5Z/33) of platforminfo4XI5TEST *** FAILED TO CREATE PLATFORMINFO4XI OBJECT')
    
    # ---------------------------------------------------------------------------------------------
    # GET METHOD                        
    # ---------------------------------------------------------------------------------------------          
    print('(Step 6A/33) of platforminfo4XI5TEST - TRYING TO GET PLATFORM INFO')
    try:                               
        platform6xi = info2xi.get2platforminfo()                                  
        print('(Step 6B/33) of platforminfo4XI5TEST - GOT PLATFORM INFO: ', platform6xi)                            # {'profile': 'FULL_PROFILE', 'extensions': 'cl_khr_icd cl_amd_event_callback cl_amd_offline_devices cl_khr_d3d10_sharing', 'version': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'vendor': 'Advanced Micro Devices, Inc.', 'name': 'ATI Stream'}
    except:
        print('(Step 6Z/33) of platforminfo4XI5TEST *** FAILED TO GET PLATFORM INFO')   
     
    
    # ---------------------------------------------------------------------------------------------
    # SET METHOD                       
    # ---------------------------------------------------------------------------------------------          
    task4set2platforminfo = {}
    task4set2platforminfo['profile'] = 'EMBEDDED_PROFILE2'                                                          # 
    task4set2platforminfo['version'] = 'OpenCL 1.1 ATI-Stream-v2.4 (452)'                                           # 
    task4set2platforminfo['name']    = 'ATI APP2'                                                                   # 
    task4set2platforminfo['vendor']  = 'Advanced Micro Devices, Inc2.'                                              # 
    task4set2platforminfo['extensions']  = 'cl_khr_icd cl_amd_event_callback cl_amd_embedded_devices cl_khr_d3d10_sharing2'
        
    print('(Step 7A/33) of platforminfo4XI5TEST - TRYING TO SET PLATFORM INFO')
    try:                               
        platform7xi = info2xi.set2platforminfo(task4set2platforminfo)                                  
        print('(Step 7B/33) of platforminfo4XI5TEST - SET PLATFORM INFO TO: ', platform7xi)                         #  {   'profile': 'EMBEDDED_PROFILE2', 
                                                                                                                    #   'extensions': 'cl_khr_icd cl_amd_event_callback cl_amd_embedded_devices cl_khr_d3d10_sharing2',
                                                                                                                    #      'version': 'OpenCL 1.1 ATI-Stream-v2.4 (452)', 
                                                                                                                    #       'vendor': 'Advanced Micro Devices, Inc2.', 
                                                                                                                    #         'name': 'ATI APP2'
                                                                                                                    #}

    except:
        print('(Step 7Z/33) of platforminfo4XI5TEST *** FAILED TO SET PLATFORM INFO')           
            
    # ---------------------------------------------------------------------------------------------
    # RE-INITIALIZE METHOD                       
    # ---------------------------------------------------------------------------------------------              
    task4init2platforminfo = {}
    task4init2platforminfo['profile'] = 'EMBEDDED_PROFILE3'                                                         # 
    task4init2platforminfo['version'] = 'OpenCL 1.1 ATI-Stream-v2.4 (453)'                                          # 
    task4init2platforminfo['name']    = 'ATI APP3'                                                                  # 
    task4init2platforminfo['vendor']  = 'Advanced Micro Devices, Inc3.'                                             # 
    task4init2platforminfo['extensions']  = 'cl_khr_icd cl_amd_event_callback cl_amd_embedded_devices cl_khr_d3d10_sharing3'

    print('(Step 8A/33) of platforminfo4XI5TEST - TRYING TO INITIALIZE PLATFORM INFO')
    try:                               
        platform8xi = info2xi.init2platforminfo(task4init2platforminfo)                                  
        print('(Step 8B/33) of platforminfo4XI5TEST - INITIALIZED PLATFORM INFO TO: ', platform8xi)                 # {   'profile': 'EMBEDDED_PROFILE3', 
                                                                                                                    #  'extensions': 'cl_khr_icd cl_amd_event_callback cl_amd_embedded_devices cl_khr_d3d10_sharing3', 
                                                                                                                    #     'version': 'OpenCL 1.1 ATI-Stream-v2.4 (453)', 
                                                                                                                    #      'vendor': 'Advanced Micro Devices, Inc3.', 
                                                                                                                    #        'name': 'ATI APP3'
                                                                                                                    #}
  
    except:
        print('(Step 8Z/33) of platforminfo4XI5TEST *** FAILED TO INITIALIZE PLATFORM INFO')
    
    # ---------------------------------------------------------------------------------------------
    # SET METHOD AGAIN                        
    # ---------------------------------------------------------------------------------------------          
    task4init2platforminfo = {}
    task4set2platforminfo['profile'] = 'EMBEDDED_PROFILE4'                                                          # 
    task4set2platforminfo['version'] = 'OpenCL 1.1 ATI-Stream-v2.4 (454)'                                           # 
    task4set2platforminfo['name']    = 'ATI APP4'                                                                   # 
    task4set2platforminfo['vendor']  = 'Advanced Micro Devices, Inc4.'                                              # 
    task4set2platforminfo['extensions']  = 'cl_khr_icd cl_amd_event_callback cl_amd_embedded_devices cl_khr_d3d10_sharing4'
    print('(Step 9A/33) of platforminfo4XI5TEST - TRYING TO SET PLATFORM INFO')
    try:                               
        platform9xi = info2xi.set2platforminfo(task4set2platforminfo)                                  
        print('(Step 9B/33) of platforminfo4XI5TEST - SET PLATFORM INFO TO: ', platform9xi)                         # {   'profile': 'EMBEDDED_PROFILE4',
                                                                                                                    #  'extensions': 'cl_khr_icd cl_amd_event_callback cl_amd_embedded_devices cl_khr_d3d10_sharing4', 
                                                                                                                    #     'version': 'OpenCL 1.1 ATI-Stream-v2.4 (454)', 
                                                                                                                    #      'vendor': 'Advanced Micro Devices, Inc4.', 
                                                                                                                    #        'name': 'ATI APP4'
                                                                                                                    #}
 
    except:
        print('(Step 9Z/33) of platforminfo4XI5TEST *** FAILED TO SET PLATFORM INFO')   
 
    
    # ---------------------------------------------------------------------------------------------
    # GET METHOD AGAIN                        
    # ---------------------------------------------------------------------------------------------          
    print('(Step 10A/33) of platforminfo4XI5TEST - TRYING TO GET PLATFORM INFO')
    try:                               
        platform10xi = info2xi.get2platforminfo()                                  
        print('(Step 10B/33) of platforminfo4XI5TEST - GOT PLATFORM INFO: ', platform10xi)                          # {   'profile': 'EMBEDDED_PROFILE4', 
                                                                                                                    #  'extensions': 'cl_khr_icd cl_amd_event_callback cl_amd_embedded_devices cl_khr_d3d10_sharing4', 
                                                                                                                    #     'version': 'OpenCL 1.1 ATI-Stream-v2.4 (454)', 
                                                                                                                    #      'vendor': 'Advanced Micro Devices, Inc4.', 
                                                                                                                    #        'name': 'ATI APP4'
                                                                                                                    #}
 
    except:
        print('(Step 11Z/33) of platforminfo4XI5TEST *** FAILED TO GET PLATFORM INFO')          
           
    # ---------------------------------------------------------------------------------------------
    # SENSE                          
    # ---------------------------------------------------------------------------------------------    
    print('=' *33)          
    print('(Step 12A/33) of platforminfo4XI5TEST - SENSING ', time4xi())
    print('=' *33)      
    
    print(info2xi.sense())
    
    print('=' *33)          
    print('(Step 12B/33) of platforminfo4XI5TEST - SENSED ', time4xi())
    print('=' *33)     
        
    # ---------------------------------------------------------------------------------------------
    # REASON                          
    # ---------------------------------------------------------------------------------------------    
    print('=' *33)          
    print('(Step 13A/33) of platforminfo4XI5TEST - REASONING ', time4xi())
    print('=' *33)       
    
    print(info2xi.reason())
    
    print('=' *33)          
    print('(Step 13B/33) of platforminfo4XI5TEST - REASONED ', time4xi())
    print('=' *33)       
     
    # ---------------------------------------------------------------------------------------------
    # ACE                          
    # ---------------------------------------------------------------------------------------------    
    print('=' *33)          
    print('(Step 14A/33) of platforminfo4XI5TEST - ACING ', time4xi())
    print('=' *33)       
    
    print(info2xi.ace())
    
    print('=' *33)          
    print('(Step 14B/33) of platforminfo4XI5TEST - ACED ', time4xi())
    print('=' *33)           
     
    # ---------------------------------------------------------------------------------------------
    # DONE                          
    # ---------------------------------------------------------------------------------------------    
    print('=' *33)          
    print('(Step 33/33) of platforminfo4XI5TEST - DONE! ', time4xi())
    print('=' *33) 
        

#</function4xi>             
    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "main" usage = "
# main function for platforminfo4xi5test
#"> 

# -------------------------------------------------------------------------------------------------    
def main():
    global trace2scope
    global trace_object_count    
    # --------------------------------------------------------------------------------------------- 
    # INITIALIZE TRACE
    # ---------------------------------------------------------------------------------------------        
    trace2scope = Print4Xi()
    set2trace4xi()                                                                                               # trace all classes and functions in the system
    deny2trace4xi()                                                                                              # deny trace for all classes and functions in the system
    tailor2trace4xi()                                                                                            # tailor trace for this test          
    print("(Step 0A/700) OF PLATFORMINFO4XI5TEST - SENSING IT WITH YOURDRAGONXI!", time4xi()) 
    # 
    print('=' *33)
    try:            
        platforminfo4xi5test()  
        print("(Step 0A/700) OF PLATFORMINFO4XI5TEST - SENSED IT WITH YOURDRAGONXI!", time4xi()) 
        # 
        print('=' *33)
    except:
        pass
    finally:            
        # ---------------------------------------------------------------------------------------------    
        # Print Trace
        # ---------------------------------------------------------------------------------------------     
        print2trace4xi(trace2scope) 
                          
#</function4xi>
     

# -------------------------------------------------------------------------------------------------
# __main__                              
# -------------------------------------------------------------------------------------------------
if __name__ == '__main__':
    main()
#</program4xi>
 

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
# platforminfo4xi5test.txt
# sense-platforminfo4xi5test.xml
# reason-platforminfo4xi5test.xml
# ace-platforminfo4xi5test.xml
#" 
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>


#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of platforminfo4xi5test.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/> 
